﻿Enumeration
  #ca
  #siz
EndEnumeration

Enumeration
  #menu_open
  #menu_color
  #menu_save
  #menu_quit
EndEnumeration

Global Dim s.w(192)
Global Dim atri.l(255)
Global Dim atrp.l(255)
Global *m=AllocateMemory(6912)
Global *n=AllocateMemory(1)

Global fs.l=0
Global ss.l=1
Global zxa.a=$47
Global File$=""

Procedure drawzx()
  If fs<>0
    FillMemory(*m,6144,0)
    FillMemory(*m+6144,767,zxa)
    
    pp.l=0
    x.l=0
    y.l=0
    x0.l=0
    Repeat
      a.a=PeekA(*n+pp)
      pp+1
      ;If y<192
      PokeA(*m+s(y)+x+x0,a)
      x+1
      If x>=ss;-1
        x=0
        y+1
        If y=192
          y=0
          x0+ss;+1
        EndIf
        ;x=0
      EndIf
      ;EndIf
    Until pp>=fs
    
    StartDrawing(CanvasOutput(#ca))
    For y.l=0 To 191
      For x.l=0 To 31
        a.a=PeekA(*m+s(y)+x)
        ca.a=PeekA(*m+6144+x+32*(y>>3))
        b.a=128
        For i=0 To 7
          If a&b
            Box(x*8+i,y,1,1,atri(ca))
          Else
            Box(x*8+i,y,1,1,atrp(ca))
          EndIf
          b>>1
        Next i
      Next x
    Next y
    StopDrawing()
  EndIf
EndProcedure

Procedure.l basecon(n$,nbase,ba$)
  res.l=0
  For i=1 To Len(n$)
    d$=UCase(Mid(n$,i,1))
    p=FindString(ba$,d$)
    If p
      res=res*nbase+p-1
    Else
      MessageRequester("Error", "Wrong character:"+d$, #PB_MessageRequester_Ok)
      Break
    EndIf
  Next i
  
  ProcedureReturn res
EndProcedure

Procedure Read_File()
  fs=FileSize(File$)
  If ReadFile(0,File$)
    *n=ReAllocateMemory(*n,fs)
    ReadData(0,*n,fs)
    CloseFile(0)
  Else
    MessageRequester("Error","error reading"+Chr($0A)+File$, #PB_MessageRequester_Ok)
    File$=""
    fs=0
  EndIf
  drawzx()
EndProcedure

;calc adresses
p=0
For k=0 To 2;2048
  For j=0 To 7;0..31,32..63
    For i=0 To 7;$4000..$4700
      hl=i*256+j*32+k*2048
      s(p)=hl
      p+1
    Next i
  Next j
Next k

;clac attributes
For i=0 To 255
  If i&64
    bri=255
  Else
    bri=127
  EndIf
  
  re=0
  gr=0
  bl=0
  
  If i&1:bl=bri:EndIf
  If i&2:re=bri:EndIf
  If i&4:gr=bri:EndIf
  atri(i)=RGB(re,gr,bl)
  
  re=0
  gr=0
  bl=0
  
  If i&8:bl=bri:EndIf
  If i&16:re=bri:EndIf
  If i&32:gr=bri:EndIf
  atrp(i)=RGB(re,gr,bl)
  
Next i


If OpenWindow(0, 0, 0, 255, 240, "Sprite to zx screen", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  CanvasGadget(#ca, 0, 0, 256, 192)
  ScrollBarGadget(#siz,  0, 194, 255,  20, 1, 31,1)
  EnableGadgetDrop(#ca,#PB_Drop_Files,#PB_Drag_Copy)
  
  StartDrawing(CanvasOutput(#ca))
  Box(0,0,256,192,0)
  StopDrawing()
  
  If CreateMenu(0, WindowID(0))    ; menu creation starts....
    MenuTitle("File")
    MenuItem(#menu_open, "Open..")
    MenuItem(#menu_color, "Fill with color..")
    MenuItem(#menu_save, "Save")
    MenuBar()
    MenuItem(#menu_quit, "Quit")
  EndIf
  
  If CountProgramParameters()
    file$=ProgramParameter(0)
    Read_File()
  EndIf
  
  isq.l=0
  Repeat
    Event = WaitWindowEvent()
    Select Event
      Case #PB_Event_CloseWindow : isq=1
      Case #PB_Event_Menu
        Select EventMenu()
          Case #menu_open :
            StandardFile$ = ""   ; set initial file+path to display
                                 ; With next string we will set the search patterns ("|" as separator) for file displaying:
                                 ;  1st: "Text (*.txt)" as name, ".txt" and ".bat" as allowed extension
                                 ;  2nd: "PureBasic (*.pb)" as name, ".pb" as allowed extension
                                 ;  3rd: "All files (*.*) as name, "*.*" as allowed extension, valid for all files
            Pattern$ = "All files (*.*)|*.*"
            Pattern = 0    ; use the first of the three possible patterns as standard
            File$ = OpenFileRequester("Please choose file to load", StandardFile$, Pattern$, Pattern)
            If File$
              ;MessageRequester("Information", "You have selected following file:" + Chr(10) + File$, 0)
              Read_File()
              ;   Else
              ;     MessageRequester("Information", "The requester was canceled.", 0) 
            EndIf
            
            
          Case #menu_quit : isq=1
          Case #menu_color : 
            I$ = InputRequester( "Title", "input number($-hex,%-binary", "$"+RSet(Hex(zxa,#PB_Byte),2,"0") )
            If I$ <> ""
              If Mid(i$,1,1)="$" Or Mid(i$,1,1)="#"
                zxa=basecon(Mid(i$,2),16,"0123456789ABCDEF")&255
                drawzx()
              ElseIf Mid(i$,1,1)="%"
                zxa=basecon(Mid(i$,2),2,"01")&255
                drawzx()
                
              Else
                zxa=basecon(i$,10,"0123456789")&255
                drawzx()
                
              EndIf
            EndIf
            
          Case #menu_save : 
            If File$<>""
              
              If CreateFile(0,File$+".scr")
                WriteData(0,*m,6912)
                CloseFile(0)
              Else
                MessageRequester("Error","error writing"+Chr($0A)+File$, #PB_MessageRequester_Ok)
              EndIf
              
            EndIf
        EndSelect
        
      Case #PB_Event_Gadget
        Select EventGadget()
          Case #siz:
            ss=GetGadgetState(#siz)
            SetWindowTitle(0,"Sprite to zx screen,"+Str(ss))
            drawzx()
        EndSelect
        
      Case #PB_Event_GadgetDrop
        Files$ = EventDropFiles()
        File$ = StringField(Files$, 01, Chr(10))
        ;         fs=FileSize(File$)
        ;         If ReadFile(0,File$)
        ;           *n=ReAllocateMemory(*n,fs)
        ;           ReadData(0,*n,fs)
        ;           CloseFile(0)
        Read_File()
        ;         Else
        ;           MessageRequester("Error","error reading"+Chr($0A)+File$, #PB_MessageRequester_Ok)
        ;           File$=""
        ;         EndIf
        ;         
    EndSelect
    
  Until isq=1;Event = #PB_Event_CloseWindow
EndIf


FreeMemory(*n)
FreeMemory(*m)
; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 19
; FirstLine = 14
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = si.ico
; Executable = spr2scr.exe